%define contentdir /var/www
%define date 20020505
%define buildweb 1
Summary: ht://Dig - Web search engine
Name: htdig
Version: 3.2.0
Release: 7.%{date}
License: GPL
Group: Applications/Internet
Source: http://www.htdig.org/files/snapshots/%{name}-%{version}b4-%{date}.tar.gz
Patch: htdig-3.1.5-rh.patch
Patch1: htdig-3.2.0b3-glibc222.patch
Patch2: htdig-3.2.0b4-xopen.patch
Patch3: htdig-3.2.0b4-h_hash.patch
Patch4: htdig-3.2.0-ac253.patch
Patch5: htdig-3.2.0-braindamage.patch
BuildRoot: %{_tmppath}/%{name}-root
Url: http://www.htdig.org/
BuildRequires: flex >= 2.5.4a-13
BuildRequires: zlib-devel
Prefix: %{_prefix}

%package web
Summary: Scripts and HTML code needed for using ht://Dig as a web search engine
Group: Applications/Internet
Requires: %{name} = %{version}

%description
The ht://Dig system is a complete world wide web indexing and searching
system for a small domain or intranet. This system is not meant to replace
the need for powerful internet-wide search systems like Lycos, Infoseek,
Webcrawler and AltaVista. Instead it is meant to cover the search needs for
a single company, campus, or even a particular sub section of a web site. As
opposed to some WAIS-based or web-server based search engines, ht://Dig can
span several web servers at a site. The type of these different web servers
doesn't matter as long as they understand the HTTP 1.0 protocol.
ht://Dig is also used by KDE to search KDE's HTML documentation.

ht://Dig was developed at San Diego State University as a way to search the
various web servers on the campus network.

%description web
The ht://Dig system is a complete world wide web indexing and searching
system for a small domain or intranet. This system is not meant to replace
the need for powerful internet-wide search systems like Lycos, Infoseek,
Webcrawler and AltaVista. Instead it is meant to cover the search needs for
a single company, campus, or even a particular sub section of a web site. As
opposed to some WAIS-based or web-server based search engines, ht://Dig can
span several web servers at a site. The type of these different web servers
doesn't matter as long as they understand the HTTP 1.0 protocol.

The %{name}-web package includes CGI scripts and HTML code needed to use
ht://Dig on a website.

ht://Dig was developed at San Diego State University as a way to search the
various web servers on the campus network.



%prep
%setup -q -n htdig-%{version}b4-%{date}
%patch -p1 -b .rh
%patch1 -p1 -b .glibc222
%patch2 -p1 -b .xopen
%patch3 -p1 -b .h_hash
%patch4 -p1 -b .ac253
%patch5 -p1 -b .braindamage

# Fix the flex output file for glibc 2.2 compatibility
cd htcommon
flex -oconf_lexer.cxx conf_lexer.lxx
cd ..

autoconf
autoreconf -f --install
cd db
autoreconf -f --install
cd ../htlib
# This is a *VERY* dirty hack, until I figure out what's
# causing this to break...
for i in *.cc; do
	mv $i $i.foo
	cat >$i <<EOF
#include <stdio.h>
#include <string.h>
EOF
	cat $i.foo >>$i
	rm -f $i.foo
done
for i in clib.h; do
	mv $i $i.foo
	cat >$i <<EOF
#include "htconfig.h"
EOF
	cat $i.foo >>$i
	rm -f $i.foo
done

%build
./configure \
        --prefix=%{_prefix} \
        --exec-prefix=%{_exec_prefix} \
        --bindir=%{_bindir} \
        --sbindir=%{_sbindir} \
        --sysconfdir=%{_sysconfdir} \
        --datadir=%{_datadir} \
        --includedir=%{_includedir} \
        --libdir=%{_libdir} \
        --libexecdir=%{_libexecdir} \
        --localstatedir=%{_localstatedir} \
        --sharedstatedir=%{_sharedstatedir} \
        --mandir=%{_mandir} \
        --infodir=%{_infodir} \
	--enable-shared \
	--with-config-dir=%{_sysconfdir} \
	--with-common-dir=%{contentdir}/html/htdig \
	--with-database-dir=/var/lib/htdig \
	--localstatedir=/var/lib/htdig \
	--with-cgi-bin-dir=%{contentdir}/cgi-bin \
	--with-image-dir=%{contentdir}/html/htdig \
	--with-search-dir=%{contentdir}/html/htdig \
	--with-default-config-file=/etc/htdig.conf \
	--with-apache=/usr/sbin/httpd \
	--with-zlib=/usr
make

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

ln $RPM_BUILD_ROOT%{contentdir}/cgi-bin/htsearch $RPM_BUILD_ROOT%{_bindir}

chmod 644 $RPM_BUILD_ROOT%{contentdir}/html/htdig/*
ln -sf search.html $RPM_BUILD_ROOT%{contentdir}/html/htdig/index.html
# now get rid of the $RPM_BUILD_ROOT paths in the conf files
for i in /etc/htdig.conf /usr/bin/rundig ; do
	perl -pi -e "s|$RPM_BUILD_ROOT||g" $RPM_BUILD_ROOT/$i
done
mkdir -p $RPM_BUILD_ROOT%{prefix}/share
mv $RPM_BUILD_ROOT%{contentdir}/html/htdig $RPM_BUILD_ROOT%{prefix}/share
ln -sf ../../../usr/share/htdig $RPM_BUILD_ROOT%{contentdir}/html/htdig

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc htdoc/*
%config /etc/htdig.conf
%dir /var/lib/htdig
%{_bindir}/*
%{_libdir}/*
%dir %{prefix}/share/htdig
%{prefix}/share/htdig/*

%if %buildweb
%files web
%defattr(-,root,root)
%{contentdir}/html/htdig
%{contentdir}/cgi-bin/*
%endif

%changelog
* Sat Aug 10 2002 Elliot Lee <sopwith@redhat.com>
- rebuilt with gcc-3.2 (we hope)

* Tue Jul 23 2002 Tim Powers <timp@redhat.com> 3.2.0-6.20020505
- build using gcc-3.2-0.1

* Fri Jun 21 2002 Tim Powers <timp@redhat.com> 3.2.0-5.20020505
- automated rebuild

* Wed Jun 19 2002 Phil Knirsch <pknirsch@redhat.com> 3.2.0-4.20020505
- Don't forcibly strip binaries

* Thu May 23 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Mon May  6 2002 Bernhard Rosenkraenzer <bero@linux-easy.com> 3.2.0-2.20020505
- Fix build with current toolchain (automake 1.6, autoconf 2.53 changes)
- Update snapshot, fixes some more problems

* Thu Jan 24 2002 Phil Knirsch <pknirsch@redhat.com>
- Updated to latest snapshot to fix several problems.
- Fixed a problem with htdig segfaulting on s390 (#58202).

* Fri Jul 20 2001 Philipp Knirsch <pknirsch@redhat.de>
- Added missing BuildRequires: zlib-devel (#49500)

* Sun Jun 24 2001 Elliot Lee <sopwith@redhat.com>
- Bump release + rebuild.

* Fri Apr 27 2001 Bill Nottingham <notting@redhat.com>
- rebuild for C++ exception handling on ia64

* Wed Mar 21 2001 Bernhard Rosenkraenzer <bero@redhat.com> 3.2.0-0.b3.4
- move pictures etc. to base package and to a directory outside of
  /var/www - The current KDevelop search function doesn't work without
  them.

* Mon Mar  5 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Add htsearch to the base package, kdevelop needs it

* Wed Jan 10 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Move the web related files to a separate package

* Tue Oct  3 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 3.2.0b2
- fix build with glibc 2.2 and gcc 2.96

* Sat Aug 19 2000 Nalin Dahyabhai <nalin@redhat.com>
- fix syntax error introduced in our patch (#16598)

* Tue Aug 1 2000 Tim Powers <timp@redhat.com>
- fixed group to be a valid one

* Mon Jul 24 2000 Prospector <prospector@redhat.com>
- rebuilt

* Wed Jul 19 2000 Nalin Dahyabhai <nalin@redhat.com>
- rebuild for Power Tools

* Thu Jun 29 2000 Nalin Dahyabhai <nalin@redhat.com>
- rebuild for Power Tools

* Sat Feb 26 2000 Nalin Dahyabhai <nalin@redhat.com>
- 3.1.5

* Wed Jan 12 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 3.1.4
- fix URL and source location

* Tue Sep 28 1999 Preston Brown <pbrown@redhat.com>
- 3.1.3 for SWS 3.1

* Wed May 05 1999 Preston Brown <pbrown@redhat.com>
- updates for SWS 3.0

* Mon Aug 31 1998 Preston Brown <pbrown@redhat.com>
- Updates for SWS 2.0

* Sat Feb 07 1998 Cristian Gafton <gafton@redhat.com>
- built against glibc
- build all the fuzzy databases before packaging, because it is time
  consuming operation and we don't want the user to be impatient
